#TEMPLATE(MVExtentionsABC,'M.Veenstra General Extentions (ABC and Legacy)'),FAMILY('ABC'),FAMILY('CW20')
#!
#! EntryPop.Tpl -  All rights reserved by Maarten Veenstra  (maarveen@planet.nl)
#! last modified: 21-March-2003  V1.5
#!
#!----------------------------------------------------------------------------
#!============================================================================
#EXTENSION(MVEntryCopyPastePopupGlobal,'MV: RightClick Copy/Paste Popup for Entry-fields Global Template'),APPLICATION #!(MVEntryPopupProcedureExtension(MVExtentionsABC)),LAST
#!--------------------------------------------------------------------------------------
#! Global Extension template adds RightClick Popup fuctionality for Entry-fields
#!
#! Written:   March 14th, 2003 by Maarten Veenstra, The Netherlands V1.0
#! Modified:  March 14th, 2003 by Maarten Veenstra       V1.1
#! Modified:  March 15th, 2003 by Tony Bowes (#!ACB)     V1.2       (added control/procedure dependant popup-choices)
#! Modified:  March 17th, 2003 by Maarten Veenstra       V1.3
#! Modified:  March 20th, 2003 by Patrick Corcuff (#!PC) V1.4       (added legacy compatibility)
#! Modified:  March 21th, 2003 by Maarten Veenstra       V1.5       (limit popup to focus + cond.cycle)
#!
#!--------------------------------------------------------------------------------------
#!                                        Main code section
#!--------------------------------------------------------------------------------------
#BOXED('Entry RightClick Copy/Paste Popup')
 #DISPLAY('')
 #DISPLAY('The Entry RightClick Popup Global Template will ')
 #DISPLAY('add a popup-procedure with Cut/Copy/Paste, which')
 #DISPLAY('is called by RightClicking an Entry- or Spin-Field.')
 #DISPLAY('For Cut/Copy, text must be selected first.')
 #DISPLAY('')
 #DISPLAY('This functionality is only added to standard ')
 #DISPLAY('Forms. An additional "Child"-extention is available')
 #DISPLAY('for the generic Window template (not a Form)')
 #DISPLAY('Note: The used buffer is limited to 1Kb text.')
 #DISPLAY('')
 #PROMPT('Only Allow RightClick on control with Focus',CHECK),%mvALlowRightClick,AT(10),DEFAULT(1)
 #PROMPT('Add extra choices to PopUp-menu',CHECK),%mvAddPopupChoices,AT(10),DEFAULT(0)
 #ENABLE(%mvAddPopupChoices)
  #BOXED('Global extra choice list')
   #BUTTON(''),MULTI(%mvNrOfExtraChoices,%mvExtraMenuChoice),REQ,INLINE
    #BOXED('')
     #DISPLAY('Enter SEPARATOR for a Separator.')
     #PROMPT('Extra Menu-Choice:', @S20),%mvExtraMenuChoice,REQ
     #PROMPT('Code to Execute:', TEXT),%mvCodeToExecute
    #ENDBOXED
   #ENDBUTTON
  #ENDBOXED
 #ENDENABLE
 #BOXED('')
 #PROMPT('Text for ''Copy'' : ',@s10),%MVCopyText, DEFAULT('')
 #PROMPT('Text for ''Cut'' : ',@s10),%MVCutText, DEFAULT('')
 #PROMPT('Text for ''Paste'' : ',@s10),%MVPasteText, DEFAULT('')
 #ENDBOXED
#ENDBOXED
#!
#ATSTART
  #DECLARE(%PUcntr)
#ENDAT
#!
#!-----------------------------------------------------------------------------
#AT(%PrepareAlerts),PRIORITY(8252) #!,WHERE(%HasTemplate('SaveButton(Clarion)') OR %HasTemplate('SaveButton(ABC)'))
#!-----------------------------------------------------------------------------
 %Window{PROP:Alrt,254} = MouseRight
#ENDAT
#!
#!--------------------------------------------------------------------------------------
#AT(%WindowEventHandling,'PreAlertKey') #!,WHERE(%HasTemplate('SaveButton(Clarion)') OR %HasTemplate('SaveButton(ABC)'))
#!--------------------------------------------------------------------------------------
 IF KeyCode() = MouseRight or KeyCode()=93  !. : keycode()=93
   MVFeq = FOCUS()
   IF MVFeq{PROP:Type}=CREATE:Entry OR MVFeq{PROP:Type}=CREATE:Spin
 #! ACB - large changes to this section
     MVpopupText = '' 
 #EMBED(%mvEntryPopupBuildPopupTextEmbed,'mvEntry-Popup Build Extra Local Menu-Choices'),HIDE
     MVpopupChoice = mvEntryPopup(MVpopupText)
  #SUSPEND
   #?IF MVpopupChoice > 0
     #EMBED(%mvEntryPopupProcessEmbed,'mvEntry-Popup Process Extra Local Menu-Choices'),HIDE
   #?END  !MVpopupChoice
  #RESUME
   ELSIF MVFeq{PROP:Type}=CREATE:Text
    CYCLE
   END
 END
 #!ACB
#ENDAT
#!
#!--------------------------------------------------------------------------------------
#AT(%GlobalData)
#!-----------------------------------------------------------------------------
MVpopupText     STRING(1024)            
MVpopupChoice   LONG
MVfeq LONG
#ENDAT
#!
#!--------------------------------------------------------------------------------------
#AT(%GlobalMap)
#!--------------------------------------------------------------------------------------
 mvEntryPopup(String),Long
#ENDAT
#!
#!--------------------------------------------------------------------------------------
#AT(%ProgramProcedures)
#!--------------------------------------------------------------------------------------
 !-----------------------------------------------------------
 ! popup-   
 !-----------------------------------------------------------
mvEntryPopup       FUNCTION (pPopupText)        
RetValue           LONG,AUTO
PopupChoice        LONG,AUTO                    
fFeq               LONG,AUTO
#IF(%mvALlowRightClick)
fFeqX              SHORT,AUTO
fFeqY              SHORT,AUTO
fFeqW              SHORT,AUTO
fFeqH              SHORT,AUTO
#ENDIF
ClipboardText      CSTRING(256),AUTO
FullText           STRING(255),AUTO
fSelStart          SHORT,AUTO
fSelEnd            SHORT,AUTO
SelectedText       STRING(255),AUTO
PopupText          CSTRING(1024),AUTO

  CODE
  fFeq = FOCUS()
  IF ~fFeq THEN RETURN(-1) .                    !No control has Focus
  IF  fFeq{PROP:Type} <> Create:Entry |         !Is the control an Entry-field
  AND fFeq{PROP:Type} <> Create:Spin  |         !or a Spin-field ?
  AND fFeq{PROP:Type} <> Create:Combo |         !or a Combo-field ?
!  AND fFeq{PROP:Type} <> Create:Text
    RETURN(0)
  END
#IF(%mvALlowRightClick)
  fFeqX = fFeq{PROP:Xpos}
  fFeqY = fFeq{PROP:Ypos}
  fFeqW = fFeq{PROP:Width}
  fFeqH = fFeq{PROP:Height}
  if keycode()<>93   !.
     IF NOT INRANGE(MouseX(), fFeqX, fFeqX+fFeqW) |
     OR NOT INRANGE(MouseY(), fFeqY, fFeqY+fFeqH)
       RETURN(-1)
     END 
  END
#ENDIF
  ClipboardText = CLIP(CLIPBOARD(1))            !We want text only
  fSelStart     = fFeq{PROP:SelStart}
  fSelEnd       = fFeq{PROP:SelEnd}
  FullText      = fFeq{PROP:ScreenText}
  SelectedText  = FullText[fSelStart : fSelEnd]
  IF fFeq{PROP:Upr}
    ClipboardText = UPPER(ClipboardText)
  END
  IF ~fSelEnd                                   !No text is selected
    IF ClipboardText = '' or fFeq{PROP:READONLY}=True                      !Nothing to paste on the Clipboard
#IF(NOT %mvAddPopupChoices)
    IF CLIP(pPopupText) = '' THEN RETURN(-1) . !No Extra menu-choices passed
#ENDIF
      PopupText = '~' & '%MVCutText' & '|~' & '%MVCopyText' & '|~' & '%MVPasteText'
    ELSE
      PopupText = '~' & '%MVCutText' & '|~' & '%MVCopyText' & '|' & '%MVPasteText'
    END
  ELSE
    IF fFeq{PROP:PASSWORD}=True
      IF ClipboardText = '' OR fFeq{PROP:READONLY}=True
        PopupText = '~' & '%MVCutText' & '|~' & '%MVCopyText' & '|~' & '%MVPasteText'
      ELSE
        PopupText = '~' & '%MVCutText' & '|~' & '%MVCopyText' & '|' & '%MVPasteText'
      END
    ELSE
      IF fFeq{PROP:READONLY}=True
        PopupText = '~' & '%MVCutText' & '|' & '%MVCopyText' & '|~' & '%MVPasteText'
      ELSIF ClipboardText = ''
        PopupText = '' & '%MVCutText' & '|' & '%MVCopyText' & '|~' & '%MVPasteText'
      ELSE
        PopupText = '' & '%MVCutText' & '|' & '%MVCopyText' & '|' & '%MVPasteText'
      END
    END
  END
#IF(%mvAddPopupChoices)
  PopupText = PopupText & '|-'
 #FOR(%mvNrOfExtraChoices)
  #IF(%mvExtraMenuChoice='SEPARATOR')
  PopupText = PopupText & '|-'
  #ELSE
  PopupText = PopupText & '|' & '%mvExtraMenuChoice'
  #ENDIF
 #ENDFOR
#ENDIF
  IF CLIP(pPopupText) <> ''
    PopupText = PopupText & '|-|' & pPopupText
  END
  RetValue    = -1                              !Signal 'No Cycle' if user don't make a choice
  if keycode()=93 and (~INRANGE(MouseX(),fFeqX,fFeqX+fFeqW) OR ~INRANGE(MouseY(),fFeqY,fFeqY+fFeqH)) !.
     PopupChoice = PopUp(PopupText,fFeqX+fFeqW/5,fFeqY+fFeqH/5)
  else
     PopupChoice = PopUp(PopupText)
  end
  EXECUTE PopupChoice
    BEGIN                                       !Cut
      SETCLIPBOARD( CLIP(SelectedText) )
      IF fSelStart <= 1
        FullText = FullText[fSelEnd + 1 : 255]
      ELSE
        FullText = FullText[1 : fSelStart - 1] & FullText[fSelEnd + 1 : 255]
      END
      if fFeq{PROP:READONLY}=False
        CHANGE(fFeq, CLIP(FullText))
        fFeq{PROP:SelStart} = fSelStart           !Re-position cursor
      end
      RetValue = 0                              !Popup has executed -> Signal 'Cycle'
    END
    BEGIN                                       !Copy
      SETCLIPBOARD( CLIP(SelectedText) )
      !. 
      select(fFeq+1)
      select(fFeq,fSelStart,fSelEnd)
      !. 
      RetValue = 0                              !Popup has executed -> Signal 'Cycle'
    END
    BEGIN                                       !Paste
      IF fSelStart <= 1
        IF ~fSelEnd
          FullText = ClipboardText & FullText
        ELSE
          FullText = ClipboardText & FullText[fSelEnd + 1 : 255]
        END
      ELSE
        IF ~fSelEnd
          FullText = FullText[1 : fSelStart - 1] & ClipboardText & FullText[fSelStart : 255]
        ELSE
          FullText = FullText[1 : fSelStart - 1] & ClipboardText & FullText[fSelEnd + 1 : 255]
        END
      END
      if fFeq{PROP:READONLY}=False
         CHANGE(fFeq, CLIP(FullText))
         fSelStart += LEN(CLIP(ClipboardText))
         !.   6.1 - 
         select(fFeq+1)
         select(fFeq,fSelStart)
         !fFeq{PROP:SelStart} = fSelStart           !Re-position cursor
         !.   6.1 - 
      end
      RetValue = 0                              !Popup has executed -> Signal 'Cycle'
    END
#SET(%PUcntr,0)
#IF(%mvAddPopupChoices)
 #FOR(%mvNrOfExtraChoices)
  #IF(%mvExtraMenuChoice<>'SEPARATOR')
   #SET(%PUcntr,%PUcntr+1)
    BEGIN
      #EMBED(%mvEntryPopupGlobalEmbed,'mvEntry-Popup Extra Global Menu-Choices'),%mvExtraMenuChoice
      %mvCodeToExecute
      RetValue = 0                              !Popup has executed -> Signal 'Cycle'
    END
  #ENDIF
 #ENDFOR
#ENDIF
    ELSE
      ! Return the choice back to the calling procedure for procedure / control specific handling
      IF PopupChoice <> 0
        RetValue = PopupChoice - (3+%PUcntr)    !popup choice above the number of glogal choices processsed
      END
  END                   
  RETURN(RetValue)
#ENDAT
#!
#!============================================================================
#EXTENSION(MVEntryPopupProcedureExtension,'MV: Add extra choices for entry popup'),PROCEDURE,REQ(MVEntryCopyPastePopupGlobal)
#!--------------------------------------------------------------------------------------
#! Local Extension template adds RightClick Popup fuctionality for Entry-fields
#!
#! Written:   March 14th, 2003 by Maarten Veenstra
#! Modified:  March 15th, 2003 by Tony Bowes
#! Modified:  March 15th, 2003 by Maarten Veenstra
#! Modified:  March 17th, 2003 by Maarten Veenstra
#! Modified:  March 20th, 2003 by Patrick Corcuff
#!
#!--------------------------------------------------------------------------------------
#!                                        Main code section
#!--------------------------------------------------------------------------------------
#PREPARE
#DECLARE(%mvAllEntryControls),MULTI,UNIQUE
#EQUATE(%mvHasControls,%False)
 #ADD(%mvAllEntryControls, '-= All =-')
 #FOR(%Control)
  #IF (EXTRACT(%ControlType, 'ENTRY'))
   #ADD(%mvAllEntryControls, %Control)
   #SET(%mvHasControls,%True)
  #ENDIF
  #IF (EXTRACT(%ControlType, 'SPIN'))
   #ADD(%mvAllEntryControls, %Control)
   #SET(%mvHasControls,%True)
  #ENDIF
  #IF (EXTRACT(%ControlType, 'COMBO'))
   #ADD(%mvAllEntryControls, %Control)
   #SET(%mvHasControls,%True)
  #ENDIF
 #ENDFOR
#ENDPREPARE
#!
#RESTRICT
 #FOR(%Control)
  #IF (EXTRACT(%ControlType, 'ENTRY') OR EXTRACT(%ControlType, 'SPIN') OR EXTRACT(%ControlType, 'COMBO'))
   #ACCEPT
  #ENDIF
 #ENDFOR
 #REJECT
#ENDRESTRICT
#!
#BOXED('Procedure RightClick Copy/Paste Popup Extra Choices')
 #BUTTON(''),MULTI(%mvpNrOfExtraChoices,%mvpExtraMenuChoice & '-' & %mvpControlDependant),INLINE
  #BOXED('')
   #DISPLAY('Enter SEPARATOR for a Separator.')
   #PROMPT('Extra Menu-Choice:', @S20),%mvpExtraMenuChoice
   #ENABLE(%mvpExtraMenuChoice<>'SEPARATOR')
    #PROMPT('Code to Execute:', TEXT),%mvpCodeToExecute
    #PROMPT('Only run for control:', FROM(%mvAllEntryControls)),%mvpControlDependant
   #ENDENABLE
  #ENDBOXED
 #ENDBUTTON
#ENDBOXED
#!
#!-----------------------------------------------------------------------------
#! Procs with SaveButton(Clarion)/(ABC) are already populated by MVEntryCopyPastePopupGlobal
#AT(%PrepareAlerts),PRIORITY(8252),WHERE(NOT %HasTemplate('SaveButton(Clarion)') AND NOT %HasTemplate('SaveButton(ABC)'))
#!-----------------------------------------------------------------------------
 %Window{PROP:Alrt,254} = MouseRight
#ENDAT
#!
#!--------------------------------------------------------------------------------------
#! Procs with SaveButton(Clarion)/(ABC) are already populated by MVEntryCopyPastePopupGlobal
#AT(%WindowEventHandling,'PreAlertKey'),WHERE(NOT %HasTemplate('SaveButton(Clarion)') AND NOT %HasTemplate('SaveButton(ABC)'))
#!--------------------------------------------------------------------------------------
 IF KeyCode() = MouseRight or KeyCode()=93  !. : keycode()=93
   MVFeq = FOCUS()
   IF MVFeq{PROP:Type}=CREATE:Entry OR MVFeq{PROP:Type}=CREATE:Spin
 #! ACB - large changes to this section
     MVpopupText = '' 
 #EMBED(%mvEntryPopupBuildPopupTextEmbed,'mvEntry-Popup Build Extra Local Menu-Choices'),HIDE
     MVpopupChoice = mvEntryPopup(MVpopupText)
  #SUSPEND
   #?IF MVpopupChoice > 0
     #EMBED(%mvEntryPopupProcessEmbed,'mvEntry-Popup Process Extra Local Menu-Choices'),HIDE
   #?END  !MVpopupChoice
  #RESUME
   ELSIF MVFeq{PROP:Type}=CREATE:Text
    CYCLE
   END
 END
 #!ACB
#ENDAT
#!
#!--------------------------------------------------------------------------------------
#AT(%mvEntryPopupBuildPopupTextEmbed)
#!--------------------------------------------------------------------------------------
 #SET(%PUcntr,0)
 #FOR(%mvpNrOfExtraChoices)
  #SET(%PUcntr,%PUcntr+1)
  #IF(%mvpExtraMenuChoice='SEPARATOR')
  MVpopupText = CLIP(MVpopupText) & '|-'
  #ELSE
   #IF(%mvpControlDependant AND %mvpControlDependant<>'-= All =-')
  IF FOCUS() = %mvpControlDependant
   #ENDIF
   #IF (%PUcntr=1)
    MVpopupText = '%mvpExtraMenuChoice'
   #ELSE
    MVpopupText = CLIP(MVpopupText) & '|' & '%mvpExtraMenuChoice'
   #ENDIF
   #IF (%mvpControlDependant AND %mvpControlDependant<>'-= All =-')
  END
   #ENDIF
  #ENDIF
 #ENDFOR
#ENDAT
#!
#!--------------------------------------------------------------------------------------
#AT(%mvEntryPopupProcessEmbed)
#!--------------------------------------------------------------------------------------
 #SUSPEND
 #?! Pre-process the result depending on control specific selections
 #SET(%PUcntr,0)                
 #FOR(%mvpNrOfExtraChoices)
  #SET(%PUcntr,%PUcntr+1)
  #IF (%mvpControlDependant AND %mvpControlDependant<>'-= All =-')
 IF MVpopupChoice >= %PUcntr AND FOCUS() <> %mvpControlDependant
   ! There is a field specific value that was not used in the making of this popup.
   ! increment the choice to mimic this menu item being there
   MVpopupChoice += 1    
 END
  #ENDIF
 #ENDFOR
 #RESUME
 EXECUTE MVpopupChoice
 #FOR(%mvpNrOfExtraChoices)
  #IF(%mvpExtraMenuChoice<>'SEPARATOR')
 BEGIN  
   #EMBED(%mvpEntryPopupProcProcessEmbed,'mvEntry-Popup Extra Menu-Choices'),%mvpExtraMenuChoice
   %mvpCodeToExecute
 END  
  #ENDIF
 #ENDFOR
 ELSE
   Message('Incorrect usage of popup template') !debug
 END  !Execute
#ENDAT
#!============================================================================
#!
#! -------------------------------------------------------------------------
#GROUP(%HasTemplate,STRING %PassedTemplate),AUTO,PRESERVE
#! -------------------------------------------------------------------------
  #FOR(%ActiveTemplate),WHERE(%ActiveTemplate=%PassedTemplate)
     #RETURN(%True)
  #ENDFOR
  #RETURN(%False)
#!============================================================================

